/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by informer-gen. DO NOT EDIT.

package v1beta2

import (
	"context"
	time "time"

	awsv1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	versioned "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/clientset/versioned"
	internalinterfaces "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/informers/externalversions/internalinterfaces"
	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-aws/listers/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// AWSClusterInformer provides access to a shared informer and lister for
// AWSClusters.
type AWSClusterInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta2.AWSClusterLister
}

type aWSClusterInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewAWSClusterInformer constructs a new informer for AWSCluster type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewAWSClusterInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredAWSClusterInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredAWSClusterInformer constructs a new informer for AWSCluster type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredAWSClusterInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InfrastructureV1beta2().AWSClusters(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.InfrastructureV1beta2().AWSClusters(namespace).Watch(context.TODO(), options)
			},
		},
		&awsv1beta2.AWSCluster{},
		resyncPeriod,
		indexers,
	)
}

func (f *aWSClusterInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredAWSClusterInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *aWSClusterInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&awsv1beta2.AWSCluster{}, f.defaultInformer)
}

func (f *aWSClusterInformer) Lister() v1beta2.AWSClusterLister {
	return v1beta2.NewAWSClusterLister(f.Informer().GetIndexer())
}
